from pydantic import BaseModel

class ProfileFieldsBase(BaseModel):
    Field: str
    Available: int
    Title: str
    Description: str
    Displayorder: int
    Required: int
    Unchangeable: int
    Showinregister: int
    FieldLength: int

class ProfileFieldsCreate(ProfileFieldsBase):
    pass

class ProfileFields(ProfileFieldsBase):
    Id: int

    class Config:
        orm_mode = True

class QrcodeBase(BaseModel):
    Uniacid: int
    Acid: int
    Type: str
    Extra: int
    Qrcid: int
    SceneStr: str
    Name: str
    Keyword: str
    Model: int
    Ticket: str
    Url: str
    Expire: int
    Subnum: int
    Createtime: int
    Status: int

class QrcodeCreate(QrcodeBase):
    pass

class Qrcode(QrcodeBase):
    Id: int

    class Config:
        orm_mode = True

class QrcodeStatBase(BaseModel):
    Uniacid: int
    Acid: int
    Qid: int
    Openid: str
    Type: int
    Qrcid: int
    SceneStr: str
    Name: str
    Createtime: int

class QrcodeStatCreate(QrcodeStatBase):
    pass

class QrcodeStat(QrcodeStatBase):
    Id: int

    class Config:
        orm_mode = True